from enum import Enum


class AscDescEnum(str, Enum):
    ASCENDING = 'ASC'
    DESCENDING = 'DESC'


class ResolutionType(str, Enum):
    WEEK = 'w'
    DAY = 'd'
    HOUR = 'h'
    MINUTE = 'm'
    SECOND = 's'
    MILLISECOND = 'ms'
    MICROSECOND = 'u'


class AggregateType(str, Enum):
    """
    TOP, BOTTOM requires secondary parameter
    """
    MEAN = 'MEAN'
    MODE = 'MODE'
    MAX = 'MAX'
    MIN = 'MIN'
    MEDIAN = 'MEDIAN'
    FIRST = 'FIRST'
    LAST = 'LAST'
    TOP = 'TOP'
    BOTTOM = 'BOTTOM'


class EncodingType(str, Enum):
    NONE = 'NONE'
    DELTA = 'DELTA'
    DELTA_OF_DELTA = 'DELTA_OF_DELTA'
